<?php

/**
 * JoomlaWatch - A real-time ajax joomla monitor and live stats
 * @package JoomlaWatch
 * @version 1.2.18 BETA
 * @revision 507
 * @license http://www.gnu.org/licenses/gpl-3.0.txt 	GNU General Public License v3
 * @copyright (C) 2011 by Matej Koval - All rights reserved!
 * @website http://www.codegravity.com
 **/

/** ensure this file is being included by a parent file */
if (!defined('_JEXEC') && !defined('_VALID_MOS'))
    die('Restricted access');

class JoomlaWatchVisitHTML {

    var $joomlaWatch;

    function JoomlaWatchVisitHTML($joomlaWatch) {
        $this->joomlaWatch = $joomlaWatch;
    }

    function getJoinedURIRows($bots) {
        return $this->joomlaWatch->visit->getJoinedURIRows($bots);
    }

    function renderGetVars($id)
    {
        if ($this->joomlaWatch->config->isFree()) {
            return "<tr><td><span class='jwDisabled'>"._JW_ADMINHEADER_NA_IN_THIS_VERSION."</span></td></tr>";
        }
        $output = "";

        $query = sprintf("select * from #__joomlawatch_uri_post where `uriid` = '%d' and `type` = '2' ", (int) $id);

        $rows = $this->joomlaWatch->visit->database->objectListQuery($query);
        if ($rows)
            foreach ($rows as $row) {
                $key = $row->key;
                $value = $row->value;

                $output .= "<tr><td>".htmlspecialchars($key).": </td><td>".htmlspecialchars($value)."</td><td>".
                        "<a href='".$this->joomlaWatch->config->renderLink("goals","action=insert&id=".$id."&postid=".$row->id)."'
                        title='Add submitted variable as goal'><img src='".$this->joomlaWatch->config->getLiveSite()."components/com_joomlawatch/icons/goal.gif' />"._JW_VISIT_URL_PARAMETER_GOAL."</a></td></tr>";
            }

        return $output;
    }


    function renderPostVars($id)
    {
        if ($this->joomlaWatch->config->isFree()) {
            return "<tr><td><span class='jwDisabled'>"._JW_ADMINHEADER_NA_IN_THIS_VERSION."</span></td></tr>";
        }
        $output = "";

        $query = sprintf("select * from #__joomlawatch_uri_post where `uriid` = '%d' and `type` = '1' ", (int) $id);

        $rows = $this->joomlaWatch->visit->database->objectListQuery($query);
        if ($rows)
            foreach ($rows as $row) {
                $key = $row->key;
                $value = $row->value;

                $output .= "<tr><td>".htmlspecialchars($key).": </td><td>".htmlspecialchars($value)."</td><td>".
                        "<a href='".$this->joomlaWatch->config->renderLink("goals","action=insert&id=".$id."&postid=".$row->id)."' title='Add submitted variable as goal'><img src='".$this->joomlaWatch->config->getLiveSite()."components/com_joomlawatch/icons/goal.gif' />"._JW_VISIT_SUBMITED_FROM_VARIABLE."</a></td></tr>";
            }

        return $output;
    }

    /* visits */
    function renderTable($bots = false) {
	
        $rows = $this->getJoinedURIRows($bots);

        $output = "";
        $i = 0xFF;

        $decrement = -1;

        $lastIp = ""; //to be able to hide flags / address for same IP in next rows
        $lastReferer = "";
        $rowNumber = 0;

        if (@$rows)
        foreach ($rows as $row) {
            $rowNumber++;

            /* reset the values from previous iteration */

            $country = "none";
            $countryName = "";
            $countryUpper = "";
            $color = "";

            $flag = "<img src='".$this->joomlaWatch->config->getLiveSite()."components/com_joomlawatch/flags/$country.png' title='$countryName' alt='$countryName'/>";
            if ($this->joomlaWatch->block->getBlockedIp($row->ip))
                $ipString = "<s>" . htmlspecialchars($row->ip) . "</s>";
            else
                $ipString = htmlspecialchars($row->ip);

            if ($i < 0xCC || $i <= 0x00) {
                $decrement = $decrement * -1;
            }
            $i = $i + $decrement;

            $color = sprintf("%x", $i) . sprintf("%x", $i) . sprintf("%x", $i);

            if ($bots == true)
                $color = "ffffff";

            $country = $row->country;

            if (!$country) {
                $country = $this->joomlaWatch->helper->countryByIp($row->ip);
            }
            if (@ $country) {
                $countryName = $this->joomlaWatch->helper->countryCodeToCountryName($country);
                $flag = "<img src='".$this->joomlaWatch->config->getLiveSite()."components/com_joomlawatch/flags/$country.png' title='$countryName' alt='$countryName'/>";
                $countryUpper = strtoupper($country);
            }

            $userAgent = htmlspecialchars($this->joomlaWatch->visit->getBrowserByIp($row->ip));

            $browser = "";
            $os = "";
            $browserIcon = "";
            $osIcon = "";

            if (@ $userAgent) {
                $browser = $this->joomlaWatch->visit->identifyBrowser(@ $userAgent);
                if (@ $browser)
                    $browserIcon = $this->joomlaWatch->config->getLiveSite()."components/com_joomlawatch/icons/" . strtolower($browser) . ".gif";

                if (@ $browserIcon)
                    $browser = "<img src='$browserIcon' alt='$userAgent' title='$userAgent' />";

                $os = $this->joomlaWatch->visit->identifyOs(@ $userAgent);

                if (@ $os)
                    $osIcon = $this->joomlaWatch->config->getLiveSite()."components/com_joomlawatch/icons/" . strtolower($os) . ".gif";

                if (@ $osIcon)
                    $os = sprintf("<img src='%s' alt='%s' title='%s'/>", $osIcon, $userAgent, $userAgent);
            }

            if ($bots == true && $osIcon)
                continue; // bot icon fix
            if ($bots == true) {
                $osIcon = $this->joomlaWatch->config->getLiveSite()."components/com_joomlawatch/icons/blank.gif";
                $browserIcon = $this->joomlaWatch->config->getLiveSite()."components/com_joomlawatch/icons/blank.gif";
                $browser = sprintf("<img src='%s' alt='%s' title='%s' />", htmlspecialchars($browserIcon), htmlspecialchars($userAgent), htmlspecialchars($userAgent));
                $os = sprintf("<img src='%s' alt='%s' title='%s'/>", htmlspecialchars($osIcon), htmlspecialchars($userAgent), htmlspecialchars($userAgent));
            }

            // sometimes happens that timestamp is nothing
            if (!$rows[0]->timestamp)
                continue;

            $username = "";
            if (@ $row->username) {
                $username = "<br/><a href='".$this->joomlaWatch->config->getAdministratorIndex()."?option=com_users&task=view&search=$row->username' style='color: black; text-decoration:none;'><i>" . @ htmlspecialchars($row->username) . "</i></a>";
            }
            $ipString = sprintf("<a id='%s' href='javascript:blockIpToggle(\"%s\");' style='color:black;'>%s</a>", htmlspecialchars($row->ip), htmlspecialchars($row->ip), $ipString);

            $dateOfVisit = JoomlaWatchHelper::date("d.m.Y", $row->timestamp);
            if (isset($this->lastDate) && $this->lastDate != $dateOfVisit) {
                $output .= "<tr><td colspan='8' style='background-color: #".$color.";'><h3>$dateOfVisit</h3></td></tr>";
                $this->lastDate = $dateOfVisit;
            }
            $mapsIcon = "<img src='".$this->joomlaWatch->config->getLiveSite()."components/com_joomlawatch/icons/map_icon.gif' border='0' " . $this->joomlaWatch->helper->getTooltipOnEvent() . "=\"ajax_showTooltip('" . $this->joomlaWatch->config->getLiveSite() . $this->joomlaWatch->env->getEnvironmentSuffix()."components/com_joomlawatch/tooltip.php?rand=" . $this->joomlaWatch->config->getRand() . "&ip=$row->ip&env=".$this->joomlaWatch->config->getEnvironment()."',this);return false\"/>";

            $displayCountryFlag = false;
            if ($lastIp != $row->ip) {
                $displayCountryFlag = true;
                $lastIp = $row->ip;
                $rowNumber = 1;
            } else {
                $flag = ""; // do not display flag, ip if the IP is same sa previous
                $ipString = "";
            }

            if (!$displayCountryFlag) {
                $username = "";
                $browser = "";
                $os = "";
                $mapsIcon = "";
            }

            if ($lastReferer != $row->referer) {
                $output .= $this->renderRefererRow($lastReferer, $color);
                $lastReferer = $row->referer;
            }
            $output .= "<tr><td valign='top' align='left' style='background-color: #$color'></td>
																		<td valign='top' align='left' style='background-color: #$color;'>" . @ $mapsIcon . "</td><td valign='top' align='left' style='background-color: #$color; color: #999999;'>";


            if (!$countryUpper) {
                $output .= "<a href='".$this->joomlaWatch->config->renderLink("goals","action=insert&country=".@$countryUpper)."' style='color: #999999;' title='"._JW_VISITS_ADD_GOAL_COUNTRY."'>" . @ $countryUpper . "</a>";
            }



            $output .= "</td><td valign='top' align='left' style='background-color: #$color;'>" . @ $flag . "</td>
																		<td valign='top' align='left' style='background-color: #$color;'>$ipString";

            $output .= "$username</td>
																		<td valign='top' align='left' style='background-color: #$color;'>" . @ $browser . "</td>
																		<td valign='top' align='left' style='background-color: #$color;'>" . @ $os . "</td>
																		<td valign='top' align='left' style='background-color: #$color;' width='100%'>";

            $dateOfVisit = JoomlaWatchHelper::date("d.m.Y", $row->timestamp);
            $row->timestamp = JoomlaWatchHelper::date("H:i:s", $row->timestamp);
            $uriTruncated = $this->joomlaWatch->helper->truncate($row->uri);
            $row->title = $this->joomlaWatch->helper->truncate($row->title);
            $row->title = $this->joomlaWatch->helper->removeRepetitiveTitle($row->title);

            $output .= ("<div id='id$row->id' style='text-decoration: none;' onmouseout=\"toggleDiv('".$row->id."','".$row->ip."',0); highlightDiv('id".$row->id."',0);\"  onmouseover=\"toggleDiv('".$row->id."', '".$row->ip."',1); highlightDiv('id".$row->id."',1);\" style='background-color: #$color'>");

            $output .= ("$row->timestamp <a href='$row->uri' target='_blank'>$row->title</a> $uriTruncated");

            $postData = $this->joomlaWatch->visit->arePostDataForUri($row->id);

            if ($postData) {
                $output .= "<img src='".$this->joomlaWatch->config->getLiveSite()."components/com_joomlawatch/icons/submit.png' />";
            }


            /* ad as goal link */
            $output .= ("<div id='goal_".$row->id."' style='display: none; margin: 0px; padding: 2px; left: 40%;' class='uriDetailDiv'>"._JW_STATS_LOADING);

            $output .= ("</div>");
            $output .= ("</div>");


            //TODO handle post data
            if ($postData)
            {
                $postImage = "<div id='idp$row->id' onmouseout=\"toggleDiv('post_".$row->id."',0);\" onmouseover=\"toggleDiv('post_".$row->id."',1);\">";
            } else {
                $postImage = "";
            }

            $output .= $postImage;


            /* show only last URI, not all by user */
            if ($this->joomlaWatch->config->getCheckboxValue('JOOMLAWATCH_ONLY_LAST_URI')) {
                break;
            }

            $output .= ("</td></tr>");
        }
        $output .= @$this->renderRefererRow($lastReferer, $color);

        return $output;
    }

    function renderRefererRow($referer, $color) {
        if (!$referer) {
            return;
        }
        $output = "<tr>
        <td style='background-color: #".$color."'></td>
        <td style='background-color: #".$color."'></td>
        <td style='background-color: #".$color."'></td>
        <td style='background-color: #".$color."'></td>
        <td style='background-color: #".$color."'></td>
        <td style='background-color: #".$color."'></td>
        <td style='background-color: #".$color."'></td>
        <td style='background-color: #".$color."'>";

        $refererTruncated = $this->joomlaWatch->helper->truncate($referer);

        $output .= sprintf("<i style='color: gray;'> " . _JW_VISITS_CAME_FROM . ": <a href='%s' target='_blank' style='color: gray;' title='%s'>%s</a></i>", htmlspecialchars($referer), htmlspecialchars($referer), $refererTruncated);

        $phrase = $this->joomlaWatch->visit->extractPhraseFromUrl($referer);
        if (@$phrase) {
            $hostname = $this->joomlaWatch->visit->extractHostnameFromUrl($referer);
            $referer = $hostname."/search?q=".urlencode($phrase);
            $output .= sprintf("<i style='color: gray;'>"._JW_VISITS_CAME_FROM_KEYWORDS.": [<a href='%s' target='_blank' style='color: gray;' title='%s'>%s</a>]</i>", htmlspecialchars($referer), htmlspecialchars($referer), htmlspecialchars(urldecode($phrase)));
        }
        $output .= "</tr>";

        return $output;

    }

    /* visits */
    function renderVisitors() {
        $rows = $this->joomlaWatch->visit->getVisitors();
        $this->lastDate = "";
        $output = $this->renderTable(false);

        return $output;
    }

    /* visits */
    function renderBots() {

        //$rows = $this->joomlaWatch->visit->getBots();
        $this->lastDate = "";
        $output = $this->renderTable(true);

        return $output;
    }

}
